#include "PreCompiledHeaders.hh"
#include "Lib/Document/CRTPSubDocument.hh"
#include "Lib/JsonBuilder.hh"

using namespace Vivy;

// Init an audio sub-document from a file
void
AudioSubDocument::initFromPath(const QString &path)
{
    if (contextPtr)
        logDebug() << "Replacing the audio contetx by a new one for file " << VIVY_LOG_QUOTED(path);
    contextPtr.reset(new AudioContext(path)); // May throw

    logDebug() << "Audio OK for " << VIVY_LOG_QUOTED(path);
}

QString
AudioSubDocument::getElementName() const noexcept
{
    return "AudioSubDocument";
}

QJsonDocument
AudioSubDocument::getProperties() const noexcept
{
    return JsonBuilder::createOrderedJsonDocument({
        { "File", filePath },
        { "Audio context", contextPtr->getProperties().object() },
    });
}
