/* Warning, this file is autogenerated by cbindgen. Don't modify this manually. */

#pragma once

/* Generated with cbindgen:0.27.0 */

#include <inttypes.h>

#ifdef __cplusplus
namespace VVLib {
namespace C {
#endif  // __cplusplus

/**
 * Wraps the container that holds all the content of the ASS file / Vivy file.
 */
typedef struct ASSContainer ASSContainer;

/**
 * Wraps a line in an ASS file.
 */
typedef struct ASSLine ASSLine;

/**
 * Type used to describe an ASS style.
 */
typedef struct ASSStyle ASSStyle;

/**
 * Wraps syllabes, contained in lines in ASS files.
 */
typedef struct ASSSyllabe ASSSyllabe;

/**
 * Represents a string slice, the user may not modify this slice, never! Note that the string is
 * not null terminated and may contains null bytes in it, use the len attribute to get the length
 * of this string and convert it to your linking.
 *
 * # Safety
 * Note that you must always put unicode inside a string slice!
 */
typedef struct StringSlice
{
    uintptr_t len;
    const char *str;
} StringSlice;

#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

/**
 * Get the number of lines in the container.
 */
int32_t ASSContainerGetLinesCount(const struct ASSContainer *this_);

/**
 * Get the number of syllabes in the line.
 */
int32_t ASSLineGetSyllabesCount(const struct ASSLine *this_);

/**
 * Get a line by its number in the container.
 */
struct ASSLine *ASSContainerGetLineAt(struct ASSContainer *this_, int32_t idx);

/**
 * Get a syllabe in a line by its index.
 */
struct ASSSyllabe *ASSLineGetSyllabeAt(struct ASSLine *this_, int32_t idx);

/**
 * Tells whever a line is commented or not.
 */
bool ASSLineIsCommented(const struct ASSLine *this_);

/**
 * Gets the style of the line, or 'Default' if it was not found/specified.
 */
struct StringSlice ASSLineGetStyle(const struct ASSLine *this_);

/**
 * Get the content of a syllabe.
 */
struct StringSlice ASSSyllabeGetContent(const struct ASSSyllabe *this_);

/**
 * Get the duration of a syllabe.
 */
int32_t ASSSyllabeGetDuration(const struct ASSSyllabe *this_);

/**
 * Get the start of a syllabe.
 */
int32_t ASSSyllabeGetStartTime(const struct ASSSyllabe *this_);

/**
 * Get the end time of a syllabe.
 */
int32_t ASSSyllabeGetFiniTime(const struct ASSSyllabe *this_);

/**
 * Set the duration of a syllabe.
 */
void ASSSyllabeSetDuration(struct ASSSyllabe *this_, int32_t duration);

/**
 * Set the start of a syllabe.
 */
void ASSSyllabeSetStartTime(struct ASSSyllabe *this_, int32_t time);

/**
 * Set the end of a syllabe.
 */
void ASSSyllabeSetFiniTime(struct ASSSyllabe *this_, int32_t time);

/**
 * Load the ASS from a file, returns nullptr if an error was encountred.
 */
struct ASSContainer *ASSContainerFromFile(char *path);

/**
 * Get a style out of the container by its name.
 */
struct ASSStyle *ASSContainerGetStyleByName(struct ASSContainer *this_, struct StringSlice name);

/**
 * Get the name of a style by its position.
 */
struct StringSlice ASSContainerGetStyleNameAt(const struct ASSContainer *this_, int32_t idx);

/**
 * Get the number of styles in the container.
 */
int32_t ASSContainerGetStylesCount(const struct ASSContainer *this_);

/**
 * Set the start time of the line.
 */
void ASSLineSetStartTime(struct ASSLine *this_, int32_t time);

/**
 * Set the end time of a line.
 */
void ASSLineSetFiniTime(struct ASSLine *this_, int32_t time);

/**
 * Get the duration of a line.
 */
int32_t ASSLineGetDuration(const struct ASSLine *this_);

/**
 * Set the duration of a line.
 */
void ASSLineSetDuration(struct ASSLine *this_, int32_t duration);

/**
 * Get the start time of a line.
 */
int32_t ASSLineGetStartTime(const struct ASSLine *this_);

/**
 * Get the end time of a line.
 */
int32_t ASSLineGetFiniTime(const struct ASSLine *this_);

/**
 * Drop the container. It is file to pass a null pointer to this function.
 */
void ASSContainerDrop(struct ASSContainer *this_);

/**
 * Get the name of the style.
 *
 * # Safety
 * It is up to the user to ensure that the style is not dropped before the returned pointer.
 */
struct StringSlice ASSStyleGetName(const struct ASSStyle *this_);

#ifdef __cplusplus
}  // extern "C"
#endif  // __cplusplus

#ifdef __cplusplus
}  // namespace C
}  // namespace VVLib
#endif  // __cplusplus
