use crate::{ASSPosition, ASSSyllabe, AuxTable};

#[derive(Debug, Default, PartialEq)]
pub struct ASSLine<T: AuxTable> {
    pub is_comment: bool,
    pub start: i32,
    pub fini: i32,
    pub position: ASSPosition,
    pub content: Vec<ASSSyllabe<T>>,
    pub aux: T,
}

impl<T: AuxTable> Clone for ASSLine<T> {
    fn clone(&self) -> Self {
        let Self { is_comment, start, fini, position, .. } = *self;
        let content = self.content.clone();
        let aux = self.aux.deep_clone();
        Self { is_comment, start, fini, position, content, aux }
    }
}
