//! The code used to lower the Vivy Script AST into LLVM code.

mod context;
mod graph;
// mod lowerer;
mod value;

// Exports in this crate.
use crate::{context::*, graph::*, value::*};

// Re-exports.
// pub use lowerer::{Lowerer, LowererBuilder};

type LLVMLowerContext = (vvs_llvm::sys::LLVMModuleRef, vvs_llvm::sys::LLVMContextRef, vvs_llvm::sys::LLVMBuilderRef);

/// The number of temp / unnamed values.
static mut TEMP_NAME_COUNTER: u64 = 0;

#[macro_export]
macro_rules! cstr {
    ($str: literal, $($arg: expr),+ $(,)?) => {
        format!(concat!($str, "\0"), $($arg),+).as_ptr() as *const i8
    };

    () => {{
        $crate::TEMP_NAME_COUNTER += 1;
        format!(".temp.{}\0", $crate::TEMP_NAME_COUNTER).as_ptr() as *const i8
    }};
}
