#pragma once

#include "PreCompiledHeaders.hh"

namespace Vivy
{
class TimingCursor final : public QGraphicsItem {
public:
    explicit TimingCursor();

    QRectF boundingRect() const override;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget) override;

private:
    QString cursorTime;
    // FIXME
    // Forced to define a "max-width" for the text,
    // as it doesn't seem possible to get the width of the text.
    // We should try drawing it as a QGraphicsTextItem and see if
    // boundingRect()->width() is appropriate
    qreal maxWidth{ 50 }; // TODO: proper variable
    QRectF textRect;

public:
    void setTime(QString str) noexcept;

public slots:
    void onParamsChanged();
};

}
