#ifndef VIVY_SCRIPT_DOCUMENT_VIEW_H
#define VIVY_SCRIPT_DOCUMENT_VIEW_H

#ifndef __cplusplus
#error "This is a C++ header"
#endif

#include "PreCompiledHeaders.hh"
#include "VivyApplication.hh"
#include "Lib/Script/ScriptDocument.hh"
#include "UI/AbstractDocumentView.hh"

namespace Vivy
{
class ScriptDocumentView final : public AbstractDocumentView {
    Q_OBJECT
    VIVY_UNMOVABLE_OBJECT(ScriptDocumentView)
    VIVY_APP_LOGGABLE_OBJECT(ScriptDocumentView, logger)

public:
    explicit ScriptDocumentView(std::shared_ptr<ScriptDocument>, QWidget *parent = nullptr);
    ~ScriptDocumentView() override;

    void closeDocument() noexcept override;
    void openProperties() noexcept override;

    QString getDocumentTabName() const noexcept override;
    QString getDocumentTabToolTip() const noexcept override;
    QIcon getDocumentTabIcon() const noexcept override;
    AbstractDocument *getDocument() const noexcept override;

    void loadViews() noexcept override {}

    std::shared_ptr<ScriptDocument> document{ nullptr };
};
}

#endif // VIVY_PROPERTY_DOCUMENT_VIEW_H
