#include "PreCompiledHeaders.hh"
#include "UI/UnclosableDockWidget.hh"
#include "UI/DockWidgetTitleBar.hh"

using namespace Vivy;

UnclosableDockWidget::UnclosableDockWidget(const QString &name, QWidget *parent) noexcept
    : QDockWidget(name, parent)
{
    DockWidgetTitleBar::addToDock(this);
}

UnclosableDockWidget::~UnclosableDockWidget() noexcept
{
    QWidget *w = widget();
    if (w != nullptr)
        delete w;
    setWidget(nullptr);
}

void
UnclosableDockWidget::closeEvent(QCloseEvent *event) noexcept
{
    if (allowedToClose)
        QDockWidget::closeEvent(event);
    else
        event->ignore();
}

void
UnclosableDockWidget::allowClose() noexcept
{
    allowedToClose = true;
}
