#include "PreCompiledHeaders.hh"
#include "UI/VivyFileIconProvider.hh"
#include "VivyApplication.hh"

using namespace Vivy;

QIcon
VivyFileIconProvider::icon(const QFileInfo &info) const noexcept
{
    const QString name = info.fileName();
    Utils::DocumentType type;

    if (name.isEmpty() || name.isNull())
        return defaultFile;

    else if (info.isDir())
        return defaultFolder;

    else if (Utils::detectDocumentType(info, &type)) {
        if (type == Utils::DocumentType::Vivy)
            return vivyFile;
        else if (type == Utils::DocumentType::VivyScript)
            return vivyScript;
    }

    return defaultFile;
}
