#!/bin/bash

if [ ! -f compile_commands.json ]
then
    echo "Did you use cmake with the '-DCMAKE_EXPORT_COMPILE_COMMANDS=ON'"
    echo "option and copy the 'compile_commands.json' into the project's"
    echo "root folder?"
    exit 1
fi

INCLUDES=""
UNAME=$(uname -a)

# Detect Qt headers, you may add support for your distribution
uname -a | egrep -i 'ubuntu|debian' 2>/dev/null >/dev/null
if [ $? -eq 0 ]
then
    INCLUDES="-I/usr/include/x86_64-linux-gnu/qt5/QtCore -I/usr/include/x86_64-linux-gnu/qt5/QtWidgets"
    echo "Using debian/ubuntu Qt header locations"
fi

find src -name '*.cc' -exec clang-tidy {} -fix-errors -checks=modernize-* -- -std=c++20 $INCLUDES \;
find src -name '*.cc' -exec clang-tidy {} -fix-errors -checks=abseil-*    -- -std=c++20 $INCLUDES \;
find src -name '*.cc' -exec clang-tidy {} -fix-errors -checks=bugprone-*  -- -std=c++20 $INCLUDES \;
